package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TAlertExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TAlertExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andAIdIsNull() {
            addCriterion("a_id is null");
            return (Criteria) this;
        }

        public Criteria andAIdIsNotNull() {
            addCriterion("a_id is not null");
            return (Criteria) this;
        }

        public Criteria andAIdEqualTo(String value) {
            addCriterion("a_id =", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdNotEqualTo(String value) {
            addCriterion("a_id <>", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdGreaterThan(String value) {
            addCriterion("a_id >", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdGreaterThanOrEqualTo(String value) {
            addCriterion("a_id >=", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdLessThan(String value) {
            addCriterion("a_id <", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdLessThanOrEqualTo(String value) {
            addCriterion("a_id <=", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdLike(String value) {
            addCriterion("a_id like", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdNotLike(String value) {
            addCriterion("a_id not like", value, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdIn(List<String> values) {
            addCriterion("a_id in", values, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdNotIn(List<String> values) {
            addCriterion("a_id not in", values, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdBetween(String value1, String value2) {
            addCriterion("a_id between", value1, value2, "aId");
            return (Criteria) this;
        }

        public Criteria andAIdNotBetween(String value1, String value2) {
            addCriterion("a_id not between", value1, value2, "aId");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andATimeIsNull() {
            addCriterion("a_time is null");
            return (Criteria) this;
        }

        public Criteria andATimeIsNotNull() {
            addCriterion("a_time is not null");
            return (Criteria) this;
        }

        public Criteria andATimeEqualTo(Date value) {
            addCriterion("a_time =", value, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeNotEqualTo(Date value) {
            addCriterion("a_time <>", value, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeGreaterThan(Date value) {
            addCriterion("a_time >", value, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeGreaterThanOrEqualTo(Date value) {
            addCriterion("a_time >=", value, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeLessThan(Date value) {
            addCriterion("a_time <", value, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeLessThanOrEqualTo(Date value) {
            addCriterion("a_time <=", value, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeIn(List<Date> values) {
            addCriterion("a_time in", values, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeNotIn(List<Date> values) {
            addCriterion("a_time not in", values, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeBetween(Date value1, Date value2) {
            addCriterion("a_time between", value1, value2, "aTime");
            return (Criteria) this;
        }

        public Criteria andATimeNotBetween(Date value1, Date value2) {
            addCriterion("a_time not between", value1, value2, "aTime");
            return (Criteria) this;
        }

        public Criteria andATypeIsNull() {
            addCriterion("a_type is null");
            return (Criteria) this;
        }

        public Criteria andATypeIsNotNull() {
            addCriterion("a_type is not null");
            return (Criteria) this;
        }

        public Criteria andATypeEqualTo(String value) {
            addCriterion("a_type =", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeNotEqualTo(String value) {
            addCriterion("a_type <>", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeGreaterThan(String value) {
            addCriterion("a_type >", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeGreaterThanOrEqualTo(String value) {
            addCriterion("a_type >=", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeLessThan(String value) {
            addCriterion("a_type <", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeLessThanOrEqualTo(String value) {
            addCriterion("a_type <=", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeLike(String value) {
            addCriterion("a_type like", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeNotLike(String value) {
            addCriterion("a_type not like", value, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeIn(List<String> values) {
            addCriterion("a_type in", values, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeNotIn(List<String> values) {
            addCriterion("a_type not in", values, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeBetween(String value1, String value2) {
            addCriterion("a_type between", value1, value2, "aType");
            return (Criteria) this;
        }

        public Criteria andATypeNotBetween(String value1, String value2) {
            addCriterion("a_type not between", value1, value2, "aType");
            return (Criteria) this;
        }

        public Criteria andAModuleIsNull() {
            addCriterion("a_module is null");
            return (Criteria) this;
        }

        public Criteria andAModuleIsNotNull() {
            addCriterion("a_module is not null");
            return (Criteria) this;
        }

        public Criteria andAModuleEqualTo(String value) {
            addCriterion("a_module =", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleNotEqualTo(String value) {
            addCriterion("a_module <>", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleGreaterThan(String value) {
            addCriterion("a_module >", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleGreaterThanOrEqualTo(String value) {
            addCriterion("a_module >=", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleLessThan(String value) {
            addCriterion("a_module <", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleLessThanOrEqualTo(String value) {
            addCriterion("a_module <=", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleLike(String value) {
            addCriterion("a_module like", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleNotLike(String value) {
            addCriterion("a_module not like", value, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleIn(List<String> values) {
            addCriterion("a_module in", values, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleNotIn(List<String> values) {
            addCriterion("a_module not in", values, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleBetween(String value1, String value2) {
            addCriterion("a_module between", value1, value2, "aModule");
            return (Criteria) this;
        }

        public Criteria andAModuleNotBetween(String value1, String value2) {
            addCriterion("a_module not between", value1, value2, "aModule");
            return (Criteria) this;
        }

        public Criteria andALayerIsNull() {
            addCriterion("a_layer is null");
            return (Criteria) this;
        }

        public Criteria andALayerIsNotNull() {
            addCriterion("a_layer is not null");
            return (Criteria) this;
        }

        public Criteria andALayerEqualTo(String value) {
            addCriterion("a_layer =", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerNotEqualTo(String value) {
            addCriterion("a_layer <>", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerGreaterThan(String value) {
            addCriterion("a_layer >", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerGreaterThanOrEqualTo(String value) {
            addCriterion("a_layer >=", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerLessThan(String value) {
            addCriterion("a_layer <", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerLessThanOrEqualTo(String value) {
            addCriterion("a_layer <=", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerLike(String value) {
            addCriterion("a_layer like", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerNotLike(String value) {
            addCriterion("a_layer not like", value, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerIn(List<String> values) {
            addCriterion("a_layer in", values, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerNotIn(List<String> values) {
            addCriterion("a_layer not in", values, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerBetween(String value1, String value2) {
            addCriterion("a_layer between", value1, value2, "aLayer");
            return (Criteria) this;
        }

        public Criteria andALayerNotBetween(String value1, String value2) {
            addCriterion("a_layer not between", value1, value2, "aLayer");
            return (Criteria) this;
        }

        public Criteria andAThresholdIsNull() {
            addCriterion("a_threshold is null");
            return (Criteria) this;
        }

        public Criteria andAThresholdIsNotNull() {
            addCriterion("a_threshold is not null");
            return (Criteria) this;
        }

        public Criteria andAThresholdEqualTo(BigDecimal value) {
            addCriterion("a_threshold =", value, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdNotEqualTo(BigDecimal value) {
            addCriterion("a_threshold <>", value, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdGreaterThan(BigDecimal value) {
            addCriterion("a_threshold >", value, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("a_threshold >=", value, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdLessThan(BigDecimal value) {
            addCriterion("a_threshold <", value, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("a_threshold <=", value, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdIn(List<BigDecimal> values) {
            addCriterion("a_threshold in", values, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdNotIn(List<BigDecimal> values) {
            addCriterion("a_threshold not in", values, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("a_threshold between", value1, value2, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAThresholdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("a_threshold not between", value1, value2, "aThreshold");
            return (Criteria) this;
        }

        public Criteria andAStateIsNull() {
            addCriterion("a_state is null");
            return (Criteria) this;
        }

        public Criteria andAStateIsNotNull() {
            addCriterion("a_state is not null");
            return (Criteria) this;
        }

        public Criteria andAStateEqualTo(String value) {
            addCriterion("a_state =", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateNotEqualTo(String value) {
            addCriterion("a_state <>", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateGreaterThan(String value) {
            addCriterion("a_state >", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateGreaterThanOrEqualTo(String value) {
            addCriterion("a_state >=", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateLessThan(String value) {
            addCriterion("a_state <", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateLessThanOrEqualTo(String value) {
            addCriterion("a_state <=", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateLike(String value) {
            addCriterion("a_state like", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateNotLike(String value) {
            addCriterion("a_state not like", value, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateIn(List<String> values) {
            addCriterion("a_state in", values, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateNotIn(List<String> values) {
            addCriterion("a_state not in", values, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateBetween(String value1, String value2) {
            addCriterion("a_state between", value1, value2, "aState");
            return (Criteria) this;
        }

        public Criteria andAStateNotBetween(String value1, String value2) {
            addCriterion("a_state not between", value1, value2, "aState");
            return (Criteria) this;
        }

        public Criteria andAValueIsNull() {
            addCriterion("a_value is null");
            return (Criteria) this;
        }

        public Criteria andAValueIsNotNull() {
            addCriterion("a_value is not null");
            return (Criteria) this;
        }

        public Criteria andAValueEqualTo(BigDecimal value) {
            addCriterion("a_value =", value, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueNotEqualTo(BigDecimal value) {
            addCriterion("a_value <>", value, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueGreaterThan(BigDecimal value) {
            addCriterion("a_value >", value, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("a_value >=", value, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueLessThan(BigDecimal value) {
            addCriterion("a_value <", value, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("a_value <=", value, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueIn(List<BigDecimal> values) {
            addCriterion("a_value in", values, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueNotIn(List<BigDecimal> values) {
            addCriterion("a_value not in", values, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("a_value between", value1, value2, "aValue");
            return (Criteria) this;
        }

        public Criteria andAValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("a_value not between", value1, value2, "aValue");
            return (Criteria) this;
        }

        public Criteria andAWarnCountIsNull() {
            addCriterion("a_warn_count is null");
            return (Criteria) this;
        }

        public Criteria andAWarnCountIsNotNull() {
            addCriterion("a_warn_count is not null");
            return (Criteria) this;
        }

        public Criteria andAWarnCountEqualTo(Integer value) {
            addCriterion("a_warn_count =", value, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountNotEqualTo(Integer value) {
            addCriterion("a_warn_count <>", value, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountGreaterThan(Integer value) {
            addCriterion("a_warn_count >", value, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("a_warn_count >=", value, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountLessThan(Integer value) {
            addCriterion("a_warn_count <", value, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountLessThanOrEqualTo(Integer value) {
            addCriterion("a_warn_count <=", value, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountIn(List<Integer> values) {
            addCriterion("a_warn_count in", values, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountNotIn(List<Integer> values) {
            addCriterion("a_warn_count not in", values, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountBetween(Integer value1, Integer value2) {
            addCriterion("a_warn_count between", value1, value2, "aWarnCount");
            return (Criteria) this;
        }

        public Criteria andAWarnCountNotBetween(Integer value1, Integer value2) {
            addCriterion("a_warn_count not between", value1, value2, "aWarnCount");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}